%% Compare Height-map RMSE, comparing with 'ground truth'.

clear
close all
clc

ground_truth_img_path = '../GroundTruth/C0T0_GT_HM.tif';
G = double( imread(ground_truth_img_path) );

root_folder = './';
file_names = {
    'RefSurface_OptimalLocalZProjection_fs45_ms04_gauss0.33_binning2_deltaZ1.tif'
    'StackFocuser_Optimal-HM.tif'
    'Premosa_Optimal-HM_r28_d3_t16_layer0_interpolatedHeightMap.tif'
    'EDF_Optimal-HM.tif'
    'MinCostZSurface_Optimal-HM-1surface-rxy0.5-rz1-dz2.tif'
    'FastSME-Optimal-HM-Live-Notum-2018_03_08_cad_cic_LSM-C0T0_SME_ZMAP_ref1_nCH1_CF.tif'
    'RefSurface_OptimalLocalZProjection_fs11_ms04_gauss0.33_binning7_deltaZ1.tif'
    };

methods = {
    'Local Z Projector'
    'Stack Focuser'
    'PreMosa'
    'E.D.F.'
    'Min Cost Z S.'
    'Fast SME'
    'Local Z Projector #Good'
};

mask_path =  '../GroundTruth/ProjectionMask.tif';
M = logical ( imread( mask_path) );

%% Loop over files.

n_files = numel( file_names );
rmse        = NaN( n_files, 1 );

for i = 1 : n_files
  
    file_name = file_names{ i };
    I = double( imread( fullfile( root_folder, file_names{i} ) ) );
    rmse( i ) = sqrt( immse( G(M), I(M) ) );

end
