# Running the FastSME method on the test image.

## Getting the FastSME code.

In this folder, clone the Github repository where the FastSME MATLAB code is located:

```bash
git clone git@github.com:Shihav/FastSME.git
```

## Running FastSME.

In MATLAB, move to the `FastSME` you just cloned.

Then run

```matlab
>> FastSME
```

The software will give you instructions. Here is what to answer:

- How to proceed: select *Single image*

![Screenshot 2021-03-11 092918](docs\Screenshot 2021-03-11 092918.png)

- Image to open: browse to the source image file in the top level folder of the comparison toolbox.

- Imaging modality: select *Confocal (CF)*.

![Screenshot 2021-03-11 092221](docs\Screenshot 2021-03-11 092221.png)

- Image parameters: select the following:

![Screenshot 2021-03-11 092400](docs\Screenshot 2021-03-11 092400.png)

The only parameter we can vary with the FastSME method is how many layers to include in the local projection. These are the two last items on this window. You will have to re-run the projection by varying them from 0 to *e.g.* 5.

The projection and height-map will be saved in a new folder in the top level folder of the comparison toolbox, with the same name that of the image. Move the two images in the `Results` folder in the FastSME folder.

For each run, save the timings returned by the MATLAB script in a `Timings.csv` file, containing in the first column the DeltaZ value, and in the second column the timing in seconds. It should resemble this:

![Screenshot 2021-03-11 0941362](docs\Screenshot 2021-03-11 0941362.png)



## Measuring the RMSE values.

Check the `ComputeRMSE.m` script in the FastSME folder. Make sure the paths to the files are correct. Also check that the header in the `Timings` text file will properly be imported. Then run the script. It will generate the results plot:

![RMSE](RMSE.png)
