%% Import the big sweep all parameters results in MATLAB.

close all
clear
clc

root_folder = 'Results/SweepAll';

results_file = 'Results.csv';

rmse_table = readtable( fullfile( root_folder, results_file ) );
rmse_table = sortrows( rmse_table, 'rmse', 'ascend' );

% writetable( rmse_table, 'RMSE_ALL.xlsx' );

fprintf('Absolute best parameter set with respect to RMSE:\n')
disp( rmse_table( 1, : ) )


%% Discover several good parameters.

% Take best RMSE with some tolerance and quickest.
bests = rmse_table( rmse_table.rmse < ( rmse_table.rmse(1) + 0.1 ) & rmse_table.time_s < 1., : );

% Sort them by time.
bests = sortrows( bests, 'time_s' );


fprintf('Good parameter set with respect to RMSE and time:\n')
disp( bests( 1, : ) )


% writetable( bests, 'RMSE_ALL-selection.xlsx' );
