import os.path
import datetime
import time
from ij import IJ
from ij.plugin  import ZProjector

'''
Time the MIP method, taking the median of 5 runs.
'''



#------------------
# Parameters.
#------------------

save_folder = 'D:/Projects/DProj/DProjComparisonToolBox-02/Methods/MIP/Results'

# Store execution time.
timings = []
timings_file_path = os.path.join( save_folder, 'OptimalTimings.txt' )
with open( timings_file_path, 'w+' ) as f:
	f.write( 'MIP timing.\n' )
	f.write( 'Started on %s\n' % datetime.datetime.now()  )


# What channel to use to create the reference surface?
channel = 0

print( '\n\n\n\n____________________________________' )
print( 'Starting. %s' % datetime.datetime.now() )
print( 'MIP' )

for i in range( 5 ):

	
	# Execute local Z projection.
	start = time.time()

	imp = IJ.getImage()
	ZProjector.run( imp, "max" )

	end = time.time()
	deltaT = end - start
	timings.append( deltaT )
	
	# Save timings
	with open( timings_file_path, 'a' ) as f:
		f.write( "run %d: %s s.\n" % ( i, deltaT ) )

print( 'Finished! - %s' % datetime.datetime.now() )
