# Running the MinCostZSurface method on the test image.

## Getting the plugin.

The MinCostZSurface  (MCZS) method is offered as Fiji plugin, available by subscribing to a Fiji update site. In Fiji, go to the _Help > Update_ menu. In the Fiji updater, click on the `Manage update sites` button, and in the dialog that shows up, select the _SCF MPI CBG_ site:

![Screenshot 2021-03-12 115220](docs\Screenshot 2021-03-12 115220.png)

## Running the plugin.

I did not automatize running the plugin, as there is very little parameters to tune.

To run the tests:

- Open the 3D source image
- Duplicate it (*Shift + D*)
- Invert the duplicated image (*Shift + I*)
- Run the MCZS plugin (*Plugins > Min cost Z Surface*)

You need to set the *cost image* parameter to the inverted duplicated image you just created:

![Screenshot 2021-03-12 120918](docs\Screenshot 2021-03-12 120918.png)

If you choose value for the `display volume(s) contiguous to the surface(s)` larger than 1, the plugin will return a stack, that you will have to project on a 2D plane with the *Image > Stack > Z Project...* before saving. The save the resulting projection in the `Results`  folder with a naming that stores the parameter values. For instance:

![Screenshot 2021-03-12 125759](docs\Screenshot 2021-03-12 125759.png)

## Measuring the RMSE values.

Check the `ComputeRMSE.m` MATLAB script. Because there is only a few images in this script you will have to enter the file names and the legend by hand. It also need to know the path to ground truth and to the tissue mask image. For instance:

![Screenshot 2021-03-12 121118](docs\Screenshot 2021-03-12 121118.png)

It will generate a plot like the following:

<img src="D:\Projects\DProj\DProjComparisonToolBox-02\Methods\MinCostSurface\RMSE.png" alt="RMSE" style="zoom:36%;" />

Once you have identified the best parameters, save the resulting projection and height-map (termed "altitude map" here) for other metrics.

## Timing the plugin.

Timing the plugin is difficult as we do not have a way to launch it programmatically. So you will have to time it manually, with a timer.
