# Running the PreMosa method on the test image.

## Getting the executable.

PreMosa is available as a C++ program, and must be run the command line. The authors made some pre-compiled binaries for Linux and MacOSX that you can find at:

 https://github.com/CBlasse/premosa/tree/master/precompilesBinaries

Depending on your OS, download one of these two folders, and put them in the `PreMosaExecutable` of this folder.

## Running the comparison for  the `distance` and `grid_size` parameters.

To facilitate running PreMosa on many parameters, we made several Python scripts. Contrary to the Jython scripts used for other methods (that needed to be run from Fiji), these scripts are proper Python script and you must run them from the command line, on a system where Python is installed.

Start with the `RunPreMosa.py` script. It will generate a parameter sweep for the `distance` and `grid_size` parameters, and save resulting images in the `Results/SweepGridSize` folder.

Now turn to MATLAB, and run the script `ComputeRMSE.m`. It will parse the images int the `Results/SweepGridSize` and compute the RMSE for each. It generates an annotated plot and tries to figure the optimum, but it is better to directly inspect the `RMSE.xlsx` table to find what parameters are the best.

## Running the comparison for  the `bright-pixels` parameter.

Note the optimal value for  `distance` and `grid_size` found previously, and edit the Python script `RunPreMosa_SweepBrightPixel.py`. You need to change lines 8 and 10 to input the above values. Then run the script as before.

It will generate new projection images, as well as the height-map, and save them in the `Results/SweepBrightPixels` folder.

As before, the MATLAB script `ComputeRMSE_BrightPixels.m` will compute the RMSE for all these images and determine the optimal parameter set.

## Time PreMosa.

Finally, the script `TimePreMosa.py` will time the execution of PreMosa on the optimal parameters. You need to edit lines 15 to 17 to input the optimal values before running it.
