#!/usr/bin/env python

import os.path
import datetime
import time
import os

distances = [ d for d in range( 1,  10) ]
ranges = [ r for r in range( 4, 100, 2 ) ]
save_folder = 'Results/SweepGridSize'

# Store execution time.
timings_file_path = os.path.join( save_folder, 'Timings.csv' )
with open( timings_file_path, 'w+' ) as f:
	f.write( 'PreMosa' )
	f.write( 'Started on %s\n' % datetime.datetime.now()  )
	f.write( "%s, %s, %s\n" % ( 'distance', 'grid_size', 'time_(s)' ) )

cwd = os.getcwd()
print( 'Running from %s' % cwd )

premosa_path = os.path.join( cwd, 'PreMosaExecutable', 'SurfaceExtraction' )

for d in distances:
	for r in ranges:
		command = '%s -r %d -d %d -in ../../Live-Notum-2018_03_08_cad_cic_LSM-C0T0.tif -out %s' % ( premosa_path, r, d, save_folder )
		print('Executing: %s' % command )
		start = time.time()
		os.system( command )
		end = time.time()
		deltaT = end - start

		# Save timings
		with open( timings_file_path, 'a' ) as f:
			f.write( "%d, %d, %f\n" % ( d, r, deltaT ) )

print( 'Finished! - %s' % datetime.datetime.now() )
