#!/usr/bin/env python

import os.path
import datetime
import time
import os

distance = 3
ranges = [ r for r in range( 0, 100, 1 ) ]
grid_size = 28
save_folder = 'Results/SweepBrightPixels'

cwd = os.getcwd()
print( 'Running from %s' % cwd )

premosa_path = os.path.join( cwd, 'PreMosaExecutable', 'SurfaceExtraction' )

# Store execution time.
timings_file_path = os.path.join( save_folder, 'Timings.csv' )
with open( timings_file_path, 'w+' ) as f:
	f.write( 'PreMosa' )
	f.write( 'Started on %s\n' % datetime.datetime.now()  )
	f.write( "%s, %s, %s, %s\n" % ( 'distance', 'grid_size', 'bright-pixels', 'time_(s)' ) )

for r in ranges:
	command = '%s -r %d -d %d -t %d -hmr -in ../../Live-Notum-2018_03_08_cad_cic_LSM-C0T0.tif -out %s' % ( premosa_path, grid_size, distance, r, save_folder)
	print('Executing: %s' % command )
	start = time.time()
	os.system( command )
	end = time.time()
	deltaT = end - start

	# Save timings
	with open( timings_file_path, 'a' ) as f:
		f.write( "%d, %d, %d, %f\n" % ( distance, grid_size, r, deltaT ) )

print( 'Finished! - %s' % datetime.datetime.now() )
