#!/usr/bin/env python

import os.path
import datetime
import time
import os

'''
Time the PreMosa method, using the optimal parameters determined
by parameter sweep. Best time is determined by taking the median
of 5 runs.
'''


distance = 3
grid_size = 28
bright_pixels = 16

save_folder = './'

# Store execution time.
timings_file_path = os.path.join( save_folder, 'OptimalTimings.txt' )
with open( timings_file_path, 'w+' ) as f:
	f.write( 'PreMosa ' )
	f.write( 'Started on %s\n' % datetime.datetime.now()  )

for i in range( 5 ):
	command = './PreMosaExecutable/SurfaceExtraction -hmr -r %d -d %d -t %d -in ../../C0T0.tif -out %s' % (grid_size, distance, bright_pixels, save_folder)
	print('Executing: %s' % command )
	start = time.time()
	os.system( command )
	end = time.time()
	deltaT = end - start

	# Save timings
	with open( timings_file_path, 'a' ) as f:
		f.write( "run %d: %s s.\n" % ( i, deltaT ) )

print( 'Finished! - %s' % datetime.datetime.now() )
